# Vibes SDK
Vibes SDK provide an easy to use, chainable API, that make it a breeze to interact with a Vibes node to query and manage your resources or resources from any subscribed spaces.

The following example demonstrate the use of the API to register a new space. 


    Vibes.space("https://system.vibes.io/spaces/system", {})
        .then(function(space) {
            return space.resources('/spaces');
        })
        .then(function(spaces) {
            return spaces.create("covistra", {
                space:{
                    pubkey:"",

                }
            });
        })
        .then(function(resource) {
            console.log("Resource %s was successfully created", resource.id);
        })
        }).catch(function(err) {
            throw err;
        })
        .done();


First, we instantiate a space reference by calling the **Vibes.space** method. All Vibes methods uses *promises* instead of callbacks to support advanced and easier asynchronous programming paradigm. With promises, you can 
create chained operations without nesting hell. You can also keep promises and reuse them, which isn't the case for callbacks. Reusable promises is key to Vibes performance as Vibes is a vastly distributed platform. Some resources that will already be retrieved will be quickly accessible through the resolved promise. For more information about promises and how to use them, refer to the [Promise/A](http://wiki.commonjs.org/wiki/Promises/A) specification. 

