/**
 *
 * Copyright 2013 Vibes.IO
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

var Q = require('q'),
    check = require('validator').check,
    Signer = require('./signer'),
    moment = require('moment'),
    request = require('request');

/**
 * @class ResourceSet
 * @description Abstract all features of a resource set.
 */
module.exports = (function() {

    function ResourceSet(space, key, deferredContent, options) {
        this.space = space;
        this.key = key;
        this.data = deferredContent;
        this.options = options || {};
    }

    /**
     * Add a new resource to this resource set.
     *
     * @param key
     * @param facet
     * @param options
     */
    ResourceSet.prototype.add = function(key, facet, options) {
        var _this = this;
        options = options || {};
        return _this.data.then(function() {
            return _this.space.operation(_this.key, key, {
                token:_this.space.token,
                secret:_this.space.secret,
                method:'POST',
                data:facet
            });
        });
    };

    return ResourceSet;
})();
